From b50be46d728f4aca19956373244286853a9a9a7a Mon Sep 17 00:00:00 2001
From: ChangAo Chen <cca5507@qq.com>
Date: Tue, 15 Jul 2025 17:05:03 +0800
Subject: [PATCH v1] logical replication launcher did not automatically restart
 when got SIGKILL.

The main reason is that RegisteredBgWorker::rw_pid has not been cleaned.
---
 src/backend/postmaster/bgworker.c | 1 +
 1 file changed, 1 insertion(+)

diff --git a/src/backend/postmaster/bgworker.c b/src/backend/postmaster/bgworker.c
index 116ddf7b835..11930024e78 100644
--- a/src/backend/postmaster/bgworker.c
+++ b/src/backend/postmaster/bgworker.c
@@ -192,6 +192,7 @@ BackgroundWorkerShmemInit(void)
 			slot->terminate = false;
 			slot->pid = InvalidPid;
 			slot->generation = 0;
+			rw->rw_pid = 0;
 			rw->rw_shmem_slot = slotno;
 			rw->rw_worker.bgw_notify_pid = 0;	/* might be reinit after crash */
 			memcpy(&slot->worker, &rw->rw_worker, sizeof(BackgroundWorker));
-- 
2.34.1

